#define _ON 1
#define  ON 1
#define OFF 0
#define FAST 2
#define WRAP 0xFF
const unsigned char off____Blinky_Sequence_L[] = {FAST, OFF, OFF, OFF, OFF, OFF, OFF, OFF, OFF, OFF, OFF, OFF, OFF, OFF, OFF, OFF, OFF, OFF, OFF, OFF, OFF, OFF, OFF, OFF, OFF, OFF, OFF, OFF, OFF, OFF, OFF, OFF, OFF, OFF, OFF, OFF, OFF, OFF, OFF, OFF, OFF, OFF, OFF, OFF, OFF, OFF, OFF, WRAP };
const unsigned char runningBlinky_Sequence_L[] = { OFF, OFF, _ON, OFF, OFF, _ON, _ON, _ON, _ON, OFF,  OFF,_ON, OFF, OFF, OFF, OFF, OFF, OFF, OFF, OFF, OFF, OFF, OFF, OFF, OFF, OFF, OFF, OFF, WRAP };
const unsigned char go_up__Blinky_Sequence_L[] = { OFF, _ON, OFF, OFF, _ON, OFF, OFF, _ON, _ON, _ON, _ON, _ON, _ON, OFF, OFF, OFF, OFF, OFF, WRAP };
const unsigned char go_downBlinky_Sequence_L[] = { OFF, _ON, _ON, _ON, _ON, _ON, _ON, OFF, OFF, _ON, OFF, OFF, _ON, OFF, OFF, OFF, OFF, OFF, OFF, WRAP };

unsigned long milliseconds_L;

#define LOOP_INTERVAL 30  //milliseconds. 
unsigned char twoColorExerciser_L;
#define TWOCOLOR_EXERCISE_TOP 10


//blinky messages
enum blinkyMessageType
{
   BLINKY_NONE,
   BLINKY_IDLE_OFF,
   BLINKY_IDLE_RUNNING,
   BLINKY_DOWN_PI,
   BLINKY_UP_PI
};

struct blinky_STRUCT
{
   unsigned char index;
   const unsigned char *sequenceStart;
   unsigned char divider;
   enum blinkyMessageType message;
} blinky_L;

static void UpdateBlinkyAtArduinoStatusPort(enum blinkyMessageType code_p);

#define RED_BUTTON_LED       2   //high lights green LED
#define RED_BUTTON           3   //internally pulled up - low is pressed
#define GREEN_BUTTON_LED     5   //high lights red LED
#define GREEN_BUTTON         6   //internally pulled up - low is pressed
#define MORSE_STATUS_OUT     7   //high lights blue LED
#define ALIVE_TOGGLE_FROM_PI 8   //signal from Raspberry PI toggles every 500mS if rPI is awake and running power manager software 
#define UP_SIG_FROM_PI       9   //signal from Raspberry PI is a high at the PI if rPI is awake and running power manager software
#define GO_DOWN_SIG_TO_PI    10  //signal from Arduino -- High at PI tells PI to shut-down if rPI is running power manager software
#define RELAY_CONTROL_PI_PS  11  //controls power to the rPI.  HIGH from Arduino if rPI is supposed to see VCC on USB cable
#define ARDUINO_BLINKY       13  //controls LED on the main Arduino board.  
//We're using a bidirectional voltage converter from SparkFun.  
// The unit has four signals on each side, plus voltage provided by the consumer on each side.
//The pins are labelled LV1 LV2 LV GND LV3 LV4   and then on the other side  HV1 HV2 HV GND HV3 HV4

//The Arduino is on the HV side.  
// HV1  ALIVE-TOGGLE-FROM-PI
// HV2  UP-SIG-FROM-PI
// HV3  GO-DOWN-SIG-TO-PI

//There is also a relay output from the Arduino

enum powerManagerStateType
{
   STATE_NONE,
   STATE_IDLE_OFF,
   STATE_IDLE_RUNNING,
   STATE_DOWN_PI,
   STATE_UP_PI
} powerManagerState_L;

#define PI_BLINKING_CHANGE_TIMEOUT_INIT 30
#define REQUIRED_PI_BLINKY_GOOD_TRANSITIONS_FOR_CONFIDENCE 4
unsigned int piBlinkyChangeTimeoutCounter_L;
bool         piBlinkyStatus_L;
unsigned int piBlinkyGoodTransitionsInARow_L;

void setup() 
{
  // put your setup code here, to run once:
   pinMode(RED_BUTTON,   INPUT);
   pinMode(GREEN_BUTTON, INPUT);
   pinMode(RED_BUTTON_LED,   OUTPUT); 
   pinMode(GREEN_BUTTON_LED, OUTPUT);  
   pinMode(GO_DOWN_SIG_TO_PI, OUTPUT);
   digitalWrite(GO_DOWN_SIG_TO_PI, 0);  //by default, write PI GO DOWN to false
   pinMode(ALIVE_TOGGLE_FROM_PI, INPUT);  
   pinMode(UP_SIG_FROM_PI, INPUT);  
   pinMode(RELAY_CONTROL_PI_PS, OUTPUT);
   digitalWrite(RELAY_CONTROL_PI_PS, 1);  //by default turn on the Raspberry PI
   //digitalWrite(5, 1);
   pinMode(MORSE_STATUS_OUT, OUTPUT);
   milliseconds_L = millis()+LOOP_INTERVAL;
   blinky_L.message=BLINKY_NONE;
   UpdateBlinkyAtArduinoStatusPort(BLINKY_IDLE_OFF);
   Serial.begin(9600);
   Serial.println("Hello world");
   pinMode(ARDUINO_BLINKY, OUTPUT);  
   digitalWrite(ARDUINO_BLINKY,0);
   powerManagerState_L = STATE_NONE;
   piBlinkyChangeTimeoutCounter_L = PI_BLINKING_CHANGE_TIMEOUT_INIT;
   piBlinkyStatus_L = 0;
   piBlinkyGoodTransitionsInARow_L = 0;
}


// put your main code here, to run repeatedly:
void loop() 
{
    //Serial.println("top");
    while(millis() < milliseconds_L)
    {
       //This WHILE just holds us from running until LOOP_INTERVAL number of millisecond ticks by.  
       //Because this WHILE is based on a free-running clock, it will finish holding us from running
       //at a consistant interval regardless of how long it takes to run through the rest of the program.
       //The important exception is if the program takes longer than LOOP_INTERVAL.  Then the
       //execution would be uneven but just for the period of that run through the program.
   }
   milliseconds_L += LOOP_INTERVAL;
     
   UpdateBlinkyAtArduinoStatusPort(BLINKY_NONE);
   if(piBlinkyChangeTimeoutCounter_L > 0)
   {
      piBlinkyChangeTimeoutCounter_L--;
   }
   if(piBlinkyChangeTimeoutCounter_L == 0)
   {
      piBlinkyGoodTransitionsInARow_L=0;   //no soup for you!  We've lost touch with the Raspberry PI.  PI had better be powered off! 
      powerManagerState_L = STATE_IDLE_OFF;
      Serial.println("Timeout of PI blinky");
   }
   
   {
       bool piBlinkyInput_l;
       piBlinkyInput_l = digitalRead(ALIVE_TOGGLE_FROM_PI);    //get the .5hz toggle signal from the Raspberry PI
       if(piBlinkyStatus_L != piBlinkyInput_l)                   //check if it has changed.  
       {                                                       //it did change.  Count another good transition in a row.  
           piBlinkyChangeTimeoutCounter_L = PI_BLINKING_CHANGE_TIMEOUT_INIT;
           piBlinkyStatus_L = piBlinkyInput_l;
           if(piBlinkyGoodTransitionsInARow_L < REQUIRED_PI_BLINKY_GOOD_TRANSITIONS_FOR_CONFIDENCE)
           {
              piBlinkyGoodTransitionsInARow_L++;
           }
       }
   }

   switch(powerManagerState_L)
   {
      case STATE_NONE:
         digitalWrite(GREEN_BUTTON_LED, 0);   //turn off GREEN button
         digitalWrite(RED_BUTTON_LED, 0);     //turn off RED button
         if(piBlinkyGoodTransitionsInARow_L >= REQUIRED_PI_BLINKY_GOOD_TRANSITIONS_FOR_CONFIDENCE)
          {
             powerManagerState_L = STATE_IDLE_RUNNING;
          }
          break;

      case STATE_IDLE_OFF:
          digitalWrite(GREEN_BUTTON_LED, 0);   //turn off GREEN button
          digitalWrite(RED_BUTTON_LED, 0);     //turn off RED button
          if(piBlinkyGoodTransitionsInARow_L >= REQUIRED_PI_BLINKY_GOOD_TRANSITIONS_FOR_CONFIDENCE)
          {
             powerManagerState_L = STATE_IDLE_RUNNING;
          }
         break;

      case STATE_IDLE_RUNNING:
         digitalWrite(GREEN_BUTTON_LED, 0);   //turn off GREEN button
         digitalWrite(RED_BUTTON_LED, 0);     //turn off RED button
         if(piBlinkyGoodTransitionsInARow_L < REQUIRED_PI_BLINKY_GOOD_TRANSITIONS_FOR_CONFIDENCE)
         {
            powerManagerState_L = STATE_NONE;
         }
         else if(digitalRead(GREEN_BUTTON) != 1)
         {

         break;

      case STATE_DOWN_PI:
         if(piBlinkyGoodTransitionsInARow_L < REQUIRED_PI_BLINKY_GOOD_TRANSITIONS_FOR_CONFIDENCE)
         {
            powerManagerState_L = STATE_NONE;
         }
         digitalWrite(GREEN_BUTTON_LED, 0);   //turn off GREEN button
         digitalWrite(RED_BUTTON_LED, 1);     //turn on RED button
         break;

      case STATE_UP_PI:
         digitalWrite(GREEN_BUTTON_LED, 0);   //turn off GREEN button
         digitalWrite(RED_BUTTON_LED, 1);     //turn on RED button
         if(piBlinkyGoodTransitionsInARow_L >= REQUIRED_PI_BLINKY_GOOD_TRANSITIONS_FOR_CONFIDENCE)
         {
             powerManagerState_L = STATE_IDLE_RUNNING;
         }
         break;

      default:
         break;

   
   }

   if(digitalRead(GREEN_BUTTON) != 1)
   {
      Serial.print("g=");
      UpdateBlinkyAtArduinoStatusPort(BLINKY_UP_PI);
      digitalWrite(GREEN_BUTTON_LED, 1);   //turn on GREEN button
      digitalWrite(RED_BUTTON_LED, 0);   //turn off RED button
   }
   else if(digitalRead(RED_BUTTON) != 1)
   {
      Serial.print("r=");
      UpdateBlinkyAtArduinoStatusPort(BLINKY_DOWN_PI);
      digitalWrite(GREEN_BUTTON_LED, 0);   //turn off GREEN button
      digitalWrite(RED_BUTTON_LED, 1);     //turn on RED button
   }
}

//###################################################
// UPDATE BLINKY AT ARDUINO STATUS PORT
//
// This function sends a single Morse character over and over on the blue LED so as to
// inform the user what the Arduino is trying to acheive at this time.  The codes are 
// defined in an enum at the top of this file. 
//
#define DIVIDER_START 2
static void UpdateBlinkyAtArduinoStatusPort(enum blinkyMessageType code_p)
{
   if((code_p != BLINKY_NONE) && (code_p != blinky_L.message))   //have we changed messages?
   {
      //Serial.println("c");
      blinky_L.message = code_p;
      blinky_L.divider = DIVIDER_START;      //change output states no more frequently than once every 3 LOOP_INTERVALS
      blinky_L.index = 0;
      switch(blinky_L.message)
      {
        case BLINKY_IDLE_OFF:     blinky_L.sequenceStart = &off____Blinky_Sequence_L[0];
              Serial.println("f");
              break;
              
        case BLINKY_IDLE_RUNNING: blinky_L.sequenceStart = &runningBlinky_Sequence_L[0];
              Serial.println("r");
              break;
              
        case BLINKY_DOWN_PI:      blinky_L.sequenceStart = &go_downBlinky_Sequence_L[0];
              Serial.println("d");
              break;
              
       case BLINKY_UP_PI:         blinky_L.sequenceStart = &go_up__Blinky_Sequence_L[0];
              Serial.println("u");
              break;
              
        case BLINKY_NONE:         blinky_L.sequenceStart = &off____Blinky_Sequence_L[0];
              Serial.println("n");
              break;
              
        default:                  blinky_L.sequenceStart = &off____Blinky_Sequence_L[0];
              Serial.println("d");
              break;
      }        
   }
   //Serial.println("----");
   //Serial.print("ndx=");
   //Serial.println(blinky_L.index);
   //Serial.print("val=");
   //Serial.println(blinky_L.sequenceStart[blinky_L.index]);
   if(blinky_L.divider != 0)
   {
       //Serial.println("inc divider");
       blinky_L.divider--;
       
   }
   else
   {
      unsigned char blinkOnOffResult_l;
      blinkOnOffResult_l = blinky_L.sequenceStart[blinky_L.index];

      blinky_L.divider = DIVIDER_START;

      if(blinkOnOffResult_l == WRAP)   
      {                                                                //if the element is WRAP, then go back to the start of the sequence, and then reload the first value
          //Serial.println("wrap");
          blinky_L.index = 0;                                          //back to the start of the sequence
          blinkOnOffResult_l = blinky_L.sequenceStart[blinky_L.index]; //load the first element.. then continue processing
      }
 
      if(blinky_L.sequenceStart[blinky_L.index] == FAST)
      {
          blinkOnOffResult_l = ON;                            //fast means blink, and then move immediately to the next element
          blinky_L.divider = 1;
          //Serial.println("fast");
      }
     //Serial.print("ledb=");
     //Serial.println(blinkOnOffResult_l);
     digitalWrite(MORSE_STATUS_OUT, blinkOnOffResult_l);
     blinky_L.index++;                                    //point to the next element of the message to send
   }
}

